i18n: commit: mark parseopt strings for translation
[git/jnareb-git.git] / git-rebase--interactive.sh
blob0d2056f027cbd6811faee3c45088a11b24d86102
1 #!/bin/sh
3 # Copyright (c) 2006 Johannes E. Schindelin
5 # SHORT DESCRIPTION
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 # The file containing rebase commands, comments, and empty lines.
14 # This file is created by "git rebase -i" then edited by the user. As
15 # the lines are processed, they are removed from the front of this
16 # file and written to the tail of $done.
17 todo="$state_dir"/git-rebase-todo
19 # The rebase command lines that have already been processed. A line
20 # is moved here when it is first handled, before any associated user
21 # actions.
22 done="$state_dir"/done
24 # The commit message that is planned to be used for any changes that
25 # need to be committed following a user interaction.
26 msg="$state_dir"/message
28 # The file into which is accumulated the suggested commit message for
29 # squash/fixup commands. When the first of a series of squash/fixups
30 # is seen, the file is created and the commit message from the
31 # previous commit and from the first squash/fixup commit are written
32 # to it. The commit message for each subsequent squash/fixup commit
33 # is appended to the file as it is processed.
35 # The first line of the file is of the form
36 # # This is a combination of $count commits.
37 # where $count is the number of commits whose messages have been
38 # written to the file so far (including the initial "pick" commit).
39 # Each time that a commit message is processed, this line is read and
40 # updated. It is deleted just before the combined commit is made.
41 squash_msg="$state_dir"/message-squash
43 # If the current series of squash/fixups has not yet included a squash
44 # command, then this file exists and holds the commit message of the
45 # original "pick" commit. (If the series ends without a "squash"
46 # command, then this can be used as the commit message of the combined
47 # commit without opening the editor.)
48 fixup_msg="$state_dir"/message-fixup
50 # $rewritten is the name of a directory containing files for each
51 # commit that is reachable by at least one merge base of $head and
52 # $upstream. They are not necessarily rewritten, but their children
53 # might be. This ensures that commits on merged, but otherwise
54 # unrelated side branches are left alone. (Think "X" in the man page's
55 # example.)
56 rewritten="$state_dir"/rewritten
58 dropped="$state_dir"/dropped
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 GIT_CHERRY_PICK_HELP="$resolvemsg"
81 export GIT_CHERRY_PICK_HELP
83 warn () {
84 printf '%s\n' "$*" >&2
87 # Output the commit message for the specified commit.
88 commit_message () {
89 git cat-file commit "$1" | sed "1,/^$/d"
92 orig_reflog_action="$GIT_REFLOG_ACTION"
94 comment_for_reflog () {
95 case "$orig_reflog_action" in
96 ''|rebase*)
97 GIT_REFLOG_ACTION="rebase -i ($1)"
98 export GIT_REFLOG_ACTION
100 esac
103 last_count=
104 mark_action_done () {
105 sed -e 1q < "$todo" >> "$done"
106 sed -e 1d < "$todo" >> "$todo".new
107 mv -f "$todo".new "$todo"
108 new_count=$(sane_grep -c '^[^#]' < "$done")
109 total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo")))
110 if test "$last_count" != "$new_count"
111 then
112 last_count=$new_count
113 printf "Rebasing (%d/%d)\r" $new_count $total
114 test -z "$verbose" || echo
118 make_patch () {
119 sha1_and_parents="$(git rev-list --parents -1 "$1")"
120 case "$sha1_and_parents" in
121 ?*' '?*' '?*)
122 git diff --cc $sha1_and_parents
124 ?*' '?*)
125 git diff-tree -p "$1^!"
128 echo "Root commit"
130 esac > "$state_dir"/patch
131 test -f "$msg" ||
132 commit_message "$1" > "$msg"
133 test -f "$author_script" ||
134 get_author_ident_from_commit "$1" > "$author_script"
137 die_with_patch () {
138 echo "$1" > "$state_dir"/stopped-sha
139 make_patch "$1"
140 git rerere
141 die "$2"
144 exit_with_patch () {
145 echo "$1" > "$state_dir"/stopped-sha
146 make_patch $1
147 git rev-parse --verify HEAD > "$amend"
148 warn "You can amend the commit now, with"
149 warn
150 warn " git commit --amend"
151 warn
152 warn "Once you are satisfied with your changes, run"
153 warn
154 warn " git rebase --continue"
155 warn
156 exit $2
159 die_abort () {
160 rm -rf "$state_dir"
161 die "$1"
164 has_action () {
165 sane_grep '^[^#]' "$1" >/dev/null
168 is_empty_commit() {
169 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
170 die "$1: not a commit that can be picked")
171 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
172 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
173 test "$tree" = "$ptree"
176 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
177 # GIT_AUTHOR_DATE exported from the current environment.
178 do_with_author () {
180 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
181 "$@"
185 git_sequence_editor () {
186 if test -z "$GIT_SEQUENCE_EDITOR"
187 then
188 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
189 if [ -z "$GIT_SEQUENCE_EDITOR" ]
190 then
191 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
195 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
198 pick_one () {
199 ff=--ff
201 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
202 case "$force_rebase" in '') ;; ?*) ff= ;; esac
203 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
205 if is_empty_commit "$sha1"
206 then
207 empty_args="--allow-empty"
210 test -d "$rewritten" &&
211 pick_one_preserving_merges "$@" && return
212 output git cherry-pick $empty_args $ff "$@"
215 pick_one_preserving_merges () {
216 fast_forward=t
217 case "$1" in
219 fast_forward=f
220 sha1=$2
223 sha1=$1
225 esac
226 sha1=$(git rev-parse $sha1)
228 if test -f "$state_dir"/current-commit
229 then
230 if test "$fast_forward" = t
231 then
232 while read current_commit
234 git rev-parse HEAD > "$rewritten"/$current_commit
235 done <"$state_dir"/current-commit
236 rm "$state_dir"/current-commit ||
237 die "Cannot write current commit's replacement sha1"
241 echo $sha1 >> "$state_dir"/current-commit
243 # rewrite parents; if none were rewritten, we can fast-forward.
244 new_parents=
245 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
246 if test "$pend" = " "
247 then
248 pend=" root"
250 while [ "$pend" != "" ]
252 p=$(expr "$pend" : ' \([^ ]*\)')
253 pend="${pend# $p}"
255 if test -f "$rewritten"/$p
256 then
257 new_p=$(cat "$rewritten"/$p)
259 # If the todo reordered commits, and our parent is marked for
260 # rewriting, but hasn't been gotten to yet, assume the user meant to
261 # drop it on top of the current HEAD
262 if test -z "$new_p"
263 then
264 new_p=$(git rev-parse HEAD)
267 test $p != $new_p && fast_forward=f
268 case "$new_parents" in
269 *$new_p*)
270 ;; # do nothing; that parent is already there
272 new_parents="$new_parents $new_p"
274 esac
275 else
276 if test -f "$dropped"/$p
277 then
278 fast_forward=f
279 replacement="$(cat "$dropped"/$p)"
280 test -z "$replacement" && replacement=root
281 pend=" $replacement$pend"
282 else
283 new_parents="$new_parents $p"
286 done
287 case $fast_forward in
289 output warn "Fast-forward to $sha1"
290 output git reset --hard $sha1 ||
291 die "Cannot fast-forward to $sha1"
294 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
296 if [ "$1" != "-n" ]
297 then
298 # detach HEAD to current parent
299 output git checkout $first_parent 2> /dev/null ||
300 die "Cannot move HEAD to $first_parent"
303 case "$new_parents" in
304 ' '*' '*)
305 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
307 # redo merge
308 author_script_content=$(get_author_ident_from_commit $sha1)
309 eval "$author_script_content"
310 msg_content="$(commit_message $sha1)"
311 # No point in merging the first parent, that's HEAD
312 new_parents=${new_parents# $first_parent}
313 if ! do_with_author output \
314 git merge --no-ff ${strategy:+-s $strategy} -m \
315 "$msg_content" $new_parents
316 then
317 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
318 die_with_patch $sha1 "Error redoing merge $sha1"
320 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
323 output git cherry-pick "$@" ||
324 die_with_patch $sha1 "Could not pick $sha1"
326 esac
328 esac
331 nth_string () {
332 case "$1" in
333 *1[0-9]|*[04-9]) echo "$1"th;;
334 *1) echo "$1"st;;
335 *2) echo "$1"nd;;
336 *3) echo "$1"rd;;
337 esac
340 update_squash_messages () {
341 if test -f "$squash_msg"; then
342 mv "$squash_msg" "$squash_msg".bak || exit
343 count=$(($(sed -n \
344 -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
345 -e "q" < "$squash_msg".bak)+1))
347 echo "# This is a combination of $count commits."
348 sed -e 1d -e '2,/^./{
349 /^$/d
350 }' <"$squash_msg".bak
351 } >"$squash_msg"
352 else
353 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
354 count=2
356 echo "# This is a combination of 2 commits."
357 echo "# The first commit's message is:"
358 echo
359 cat "$fixup_msg"
360 } >"$squash_msg"
362 case $1 in
363 squash)
364 rm -f "$fixup_msg"
365 echo
366 echo "# This is the $(nth_string $count) commit message:"
367 echo
368 commit_message $2
370 fixup)
371 echo
372 echo "# The $(nth_string $count) commit message will be skipped:"
373 echo
374 commit_message $2 | sed -e 's/^/# /'
376 esac >>"$squash_msg"
379 peek_next_command () {
380 sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo"
383 # A squash/fixup has failed. Prepare the long version of the squash
384 # commit message, then die_with_patch. This code path requires the
385 # user to edit the combined commit message for all commits that have
386 # been squashed/fixedup so far. So also erase the old squash
387 # messages, effectively causing the combined commit to be used as the
388 # new basis for any further squash/fixups. Args: sha1 rest
389 die_failed_squash() {
390 mv "$squash_msg" "$msg" || exit
391 rm -f "$fixup_msg"
392 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
393 warn
394 warn "Could not apply $1... $2"
395 die_with_patch $1 ""
398 flush_rewritten_pending() {
399 test -s "$rewritten_pending" || return
400 newsha1="$(git rev-parse HEAD^0)"
401 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
402 rm -f "$rewritten_pending"
405 record_in_rewritten() {
406 oldsha1="$(git rev-parse $1)"
407 echo "$oldsha1" >> "$rewritten_pending"
409 case "$(peek_next_command)" in
410 squash|s|fixup|f)
413 flush_rewritten_pending
415 esac
418 do_pick () {
419 if test "$(git rev-parse HEAD)" = "$squash_onto"
420 then
421 # Set the correct commit message and author info on the
422 # sentinel root before cherry-picking the original changes
423 # without committing (-n). Finally, update the sentinel again
424 # to include these changes. If the cherry-pick results in a
425 # conflict, this means our behaviour is similar to a standard
426 # failed cherry-pick during rebase, with a dirty index to
427 # resolve before manually running git commit --amend then git
428 # rebase --continue.
429 git commit --allow-empty --allow-empty-message --amend \
430 --no-post-rewrite -n -q -C $1 &&
431 pick_one -n $1 &&
432 git commit --allow-empty --allow-empty-message \
433 --amend --no-post-rewrite -n -q -C $1 ||
434 die_with_patch $1 "Could not apply $1... $2"
435 else
436 pick_one $1 ||
437 die_with_patch $1 "Could not apply $1... $2"
441 do_next () {
442 rm -f "$msg" "$author_script" "$amend" || exit
443 read -r command sha1 rest < "$todo"
444 case "$command" in
445 '#'*|''|noop)
446 mark_action_done
448 pick|p)
449 comment_for_reflog pick
451 mark_action_done
452 do_pick $sha1 "$rest"
453 record_in_rewritten $sha1
455 reword|r)
456 comment_for_reflog reword
458 mark_action_done
459 do_pick $sha1 "$rest"
460 git commit --amend --no-post-rewrite || {
461 warn "Could not amend commit after successfully picking $sha1... $rest"
462 warn "This is most likely due to an empty commit message, or the pre-commit hook"
463 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
464 warn "you are able to reword the commit."
465 exit_with_patch $sha1 1
467 record_in_rewritten $sha1
469 edit|e)
470 comment_for_reflog edit
472 mark_action_done
473 do_pick $sha1 "$rest"
474 warn "Stopped at $sha1... $rest"
475 exit_with_patch $sha1 0
477 squash|s|fixup|f)
478 case "$command" in
479 squash|s)
480 squash_style=squash
482 fixup|f)
483 squash_style=fixup
485 esac
486 comment_for_reflog $squash_style
488 test -f "$done" && has_action "$done" ||
489 die "Cannot '$squash_style' without a previous commit"
491 mark_action_done
492 update_squash_messages $squash_style $sha1
493 author_script_content=$(get_author_ident_from_commit HEAD)
494 echo "$author_script_content" > "$author_script"
495 eval "$author_script_content"
496 if ! pick_one -n $sha1
497 then
498 git rev-parse --verify HEAD >"$amend"
499 die_failed_squash $sha1 "$rest"
501 case "$(peek_next_command)" in
502 squash|s|fixup|f)
503 # This is an intermediate commit; its message will only be
504 # used in case of trouble. So use the long version:
505 do_with_author output git commit --amend --no-verify -F "$squash_msg" ||
506 die_failed_squash $sha1 "$rest"
509 # This is the final command of this squash/fixup group
510 if test -f "$fixup_msg"
511 then
512 do_with_author git commit --amend --no-verify -F "$fixup_msg" ||
513 die_failed_squash $sha1 "$rest"
514 else
515 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
516 rm -f "$GIT_DIR"/MERGE_MSG
517 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e ||
518 die_failed_squash $sha1 "$rest"
520 rm -f "$squash_msg" "$fixup_msg"
522 esac
523 record_in_rewritten $sha1
525 x|"exec")
526 read -r command rest < "$todo"
527 mark_action_done
528 printf 'Executing: %s\n' "$rest"
529 # "exec" command doesn't take a sha1 in the todo-list.
530 # => can't just use $sha1 here.
531 git rev-parse --verify HEAD > "$state_dir"/stopped-sha
532 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
533 status=$?
534 # Run in subshell because require_clean_work_tree can die.
535 dirty=f
536 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
537 if test "$status" -ne 0
538 then
539 warn "Execution failed: $rest"
540 test "$dirty" = f ||
541 warn "and made changes to the index and/or the working tree"
543 warn "You can fix the problem, and then run"
544 warn
545 warn " git rebase --continue"
546 warn
547 exit "$status"
548 elif test "$dirty" = t
549 then
550 warn "Execution succeeded: $rest"
551 warn "but left changes to the index and/or the working tree"
552 warn "Commit or stash your changes, and then run"
553 warn
554 warn " git rebase --continue"
555 warn
556 exit 1
560 warn "Unknown command: $command $sha1 $rest"
561 if git rev-parse --verify -q "$sha1" >/dev/null
562 then
563 die_with_patch $sha1 "Please fix this in the file $todo."
564 else
565 die "Please fix this in the file $todo."
568 esac
569 test -s "$todo" && return
571 comment_for_reflog finish &&
572 shortonto=$(git rev-parse --short $onto) &&
573 newhead=$(git rev-parse HEAD) &&
574 case $head_name in
575 refs/*)
576 message="$GIT_REFLOG_ACTION: $head_name onto $shortonto" &&
577 git update-ref -m "$message" $head_name $newhead $orig_head &&
578 git symbolic-ref \
579 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
580 HEAD $head_name
582 esac && {
583 test ! -f "$state_dir"/verbose ||
584 git diff-tree --stat $orig_head..HEAD
585 } &&
587 test -s "$rewritten_list" &&
588 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
589 true # we don't care if this copying failed
590 } &&
591 if test -x "$GIT_DIR"/hooks/post-rewrite &&
592 test -s "$rewritten_list"; then
593 "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
594 true # we don't care if this hook failed
595 fi &&
596 rm -rf "$state_dir" &&
597 git gc --auto &&
598 warn "Successfully rebased and updated $head_name."
600 exit
603 do_rest () {
604 while :
606 do_next
607 done
610 # skip picking commits whose parents are unchanged
611 skip_unnecessary_picks () {
612 fd=3
613 while read -r command rest
615 # fd=3 means we skip the command
616 case "$fd,$command" in
617 3,pick|3,p)
618 # pick a commit whose parent is current $onto -> skip
619 sha1=${rest%% *}
620 case "$(git rev-parse --verify --quiet "$sha1"^)" in
621 "$onto"*)
622 onto=$sha1
625 fd=1
627 esac
629 3,#*|3,)
630 # copy comments
633 fd=1
635 esac
636 printf '%s\n' "$command${rest:+ }$rest" >&$fd
637 done <"$todo" >"$todo.new" 3>>"$done" &&
638 mv -f "$todo".new "$todo" &&
639 case "$(peek_next_command)" in
640 squash|s|fixup|f)
641 record_in_rewritten "$onto"
643 esac ||
644 die "Could not skip unnecessary pick commands"
647 # Rearrange the todo list that has both "pick sha1 msg" and
648 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
649 # comes immediately after the former, and change "pick" to
650 # "fixup"/"squash".
651 rearrange_squash () {
652 # extract fixup!/squash! lines and resolve any referenced sha1's
653 while read -r pick sha1 message
655 case "$message" in
656 "squash! "*|"fixup! "*)
657 action="${message%%!*}"
658 rest="${message#*! }"
659 echo "$sha1 $action $rest"
660 # if it's a single word, try to resolve to a full sha1 and
661 # emit a second copy. This allows us to match on both message
662 # and on sha1 prefix
663 if test "${rest#* }" = "$rest"; then
664 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
665 if test -n "$fullsha"; then
666 # prefix the action to uniquely identify this line as
667 # intended for full sha1 match
668 echo "$sha1 +$action $fullsha"
671 esac
672 done >"$1.sq" <"$1"
673 test -s "$1.sq" || return
675 used=
676 while read -r pick sha1 message
678 case " $used" in
679 *" $sha1 "*) continue ;;
680 esac
681 printf '%s\n' "$pick $sha1 $message"
682 used="$used$sha1 "
683 while read -r squash action msg_content
685 case " $used" in
686 *" $squash "*) continue ;;
687 esac
688 emit=0
689 case "$action" in
691 action="${action#+}"
692 # full sha1 prefix test
693 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
695 # message prefix test
696 case "$message" in "$msg_content"*) emit=1;; esac ;;
697 esac
698 if test $emit = 1; then
699 printf '%s\n' "$action $squash $action! $msg_content"
700 used="$used$squash "
702 done <"$1.sq"
703 done >"$1.rearranged" <"$1"
704 cat "$1.rearranged" >"$1"
705 rm -f "$1.sq" "$1.rearranged"
708 # Add commands after a pick or after a squash/fixup serie
709 # in the todo list.
710 add_exec_commands () {
712 first=t
713 while read -r insn rest
715 case $insn in
716 pick)
717 test -n "$first" ||
718 printf "%s" "$cmd"
720 esac
721 printf "%s %s\n" "$insn" "$rest"
722 first=
723 done
724 printf "%s" "$cmd"
725 } <"$1" >"$1.new" &&
726 mv "$1.new" "$1"
729 case "$action" in
730 continue)
731 # do we have anything to commit?
732 if git diff-index --cached --quiet HEAD --
733 then
734 : Nothing to commit -- skip this
735 else
736 if ! test -f "$author_script"
737 then
738 die "You have staged changes in your working tree. If these changes are meant to be
739 squashed into the previous commit, run:
741 git commit --amend
743 If they are meant to go into a new commit, run:
745 git commit
747 In both case, once you're done, continue with:
749 git rebase --continue
752 . "$author_script" ||
753 die "Error trying to find the author identity to amend commit"
754 if test -f "$amend"
755 then
756 current_head=$(git rev-parse --verify HEAD)
757 test "$current_head" = $(cat "$amend") ||
758 die "\
759 You have uncommitted changes in your working tree. Please, commit them
760 first and then run 'git rebase --continue' again."
761 do_with_author git commit --amend --no-verify -F "$msg" -e ||
762 die "Could not commit staged changes."
763 else
764 do_with_author git commit --no-verify -F "$msg" -e ||
765 die "Could not commit staged changes."
769 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
771 require_clean_work_tree "rebase"
772 do_rest
774 skip)
775 git rerere clear
777 do_rest
779 esac
781 git var GIT_COMMITTER_IDENT >/dev/null ||
782 die "You need to set your committer info first"
784 comment_for_reflog start
786 if test ! -z "$switch_to"
787 then
788 output git checkout "$switch_to" -- ||
789 die "Could not checkout $switch_to"
792 orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
793 mkdir "$state_dir" || die "Could not create temporary $state_dir"
795 : > "$state_dir"/interactive || die "Could not mark as interactive"
796 write_basic_state
797 if test t = "$preserve_merges"
798 then
799 if test -z "$rebase_root"
800 then
801 mkdir "$rewritten" &&
802 for c in $(git merge-base --all $orig_head $upstream)
804 echo $onto > "$rewritten"/$c ||
805 die "Could not init rewritten commits"
806 done
807 else
808 mkdir "$rewritten" &&
809 echo $onto > "$rewritten"/root ||
810 die "Could not init rewritten commits"
812 # No cherry-pick because our first pass is to determine
813 # parents to rewrite and skipping dropped commits would
814 # prematurely end our probe
815 merges_option=
816 else
817 merges_option="--no-merges --cherry-pick"
820 shorthead=$(git rev-parse --short $orig_head)
821 shortonto=$(git rev-parse --short $onto)
822 if test -z "$rebase_root"
823 # this is now equivalent to ! -z "$upstream"
824 then
825 shortupstream=$(git rev-parse --short $upstream)
826 revisions=$upstream...$orig_head
827 shortrevisions=$shortupstream..$shorthead
828 else
829 revisions=$onto...$orig_head
830 shortrevisions=$shorthead
832 git rev-list $merges_option --pretty=oneline --abbrev-commit \
833 --abbrev=7 --reverse --left-right --topo-order \
834 $revisions | \
835 sed -n "s/^>//p" |
836 while read -r shortsha1 rest
839 if test -z "$keep_empty" && is_empty_commit $shortsha1
840 then
841 comment_out="# "
842 else
843 comment_out=
846 if test t != "$preserve_merges"
847 then
848 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
849 else
850 sha1=$(git rev-parse $shortsha1)
851 if test -z "$rebase_root"
852 then
853 preserve=t
854 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
856 if test -f "$rewritten"/$p
857 then
858 preserve=f
860 done
861 else
862 preserve=f
864 if test f = "$preserve"
865 then
866 touch "$rewritten"/$sha1
867 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
870 done
872 # Watch for commits that been dropped by --cherry-pick
873 if test t = "$preserve_merges"
874 then
875 mkdir "$dropped"
876 # Save all non-cherry-picked changes
877 git rev-list $revisions --left-right --cherry-pick | \
878 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
879 # Now all commits and note which ones are missing in
880 # not-cherry-picks and hence being dropped
881 git rev-list $revisions |
882 while read rev
884 if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
885 then
886 # Use -f2 because if rev-list is telling us this commit is
887 # not worthwhile, we don't want to track its multiple heads,
888 # just the history of its first-parent for others that will
889 # be rebasing on top of it
890 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
891 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
892 sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
893 rm "$rewritten"/$rev
895 done
898 test -s "$todo" || echo noop >> "$todo"
899 test -n "$autosquash" && rearrange_squash "$todo"
900 test -n "$cmd" && add_exec_commands "$todo"
902 cat >> "$todo" << EOF
904 # Rebase $shortrevisions onto $shortonto
906 # Commands:
907 # p, pick = use commit
908 # r, reword = use commit, but edit the commit message
909 # e, edit = use commit, but stop for amending
910 # s, squash = use commit, but meld into previous commit
911 # f, fixup = like "squash", but discard this commit's log message
912 # x, exec = run command (the rest of the line) using shell
914 # These lines can be re-ordered; they are executed from top to bottom.
916 # If you remove a line here THAT COMMIT WILL BE LOST.
917 # However, if you remove everything, the rebase will be aborted.
921 if test -z "$keep_empty"
922 then
923 echo "# Note that empty commits are commented out" >>"$todo"
927 has_action "$todo" ||
928 die_abort "Nothing to do"
930 cp "$todo" "$todo".backup
931 git_sequence_editor "$todo" ||
932 die_abort "Could not execute editor"
934 has_action "$todo" ||
935 die_abort "Nothing to do"
937 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
939 output git checkout $onto || die_abort "could not detach HEAD"
940 git update-ref ORIG_HEAD $orig_head
941 do_rest